%define section free

Name:           dresden-ocl
Version:        1.1
Release:        1jpp
Epoch:		1
Summary:        A compiler that generates code out of OCL expressions
License:        LGPL
URL:            http://dresden-ocl.sourceforge.net/
Source0:        http://dl.sf.net/dresden-ocl/dresden-ocl-src-1.1.tar.gz
Patch0:         %{name}-manifest.patch
Patch1:         %{name}-crosslink.patch
Group:          Development/Compilers
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Distribution:	JPackage
Vendor:         JPackage Project

BuildArch:      noarch
BuildRequires:  ant, sablecc, junit, nsuml, jdom, java-javadoc
BuildRequires:  jpackage-utils >= 0:1.5
Requires:       nsuml

%description
This is a compiler that generates code out of OCL expressions. The
generated code evaluates the OCL constraint for a model instance, i.e. a
program or data base, at runtime. Constraints formulated during analysis
and design can then easily be checked in the implementation.
While the Java code generator that is being implemented makes certain
restrictions to the OCL constructs that can be used, the other compiler
modules are implemented as close to the OCL specification of UML 1.3 as
possible.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}.

%package        argo
Summary:        Subset of %{name} required for ArgoUML
Group:          Development/Compilers

%description    argo
Subset of %{name} required for ArgoUML.


%prep
%setup -q -c
%patch0 -p1
%patch1 -p0
find . -name "*.jar" -exec rm -f {} \;


%build
export CLASSPATH=%(build-classpath sablecc junit nsuml)
ant \
  -Dbuild.compiler=modern \
  -Dj2se.javadoc=%{_javadocdir}/java \
  -Dbuild.sysclasspath=first \
  jar test.junit docs


%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 build/ocl-argo.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-argo-%{version}.jar
ln -s %{name}-argo-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-argo.jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 build/%{name}-lib.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/lib-%{version}.jar
install -m 644 build/%{name}-sql.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/sql-%{version}.jar
install -m 644 build/%{name}-demo.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/demo-%{version}.jar
install -m 644 build/%{name}-injector.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/injector-%{version}.jar
install -m 644 build/%{name}-reverseeng.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/reverseeng-%{version}.jar
install -m 644 build/royloy.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/royloy-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost


%clean
rm -rf $RPM_BUILD_ROOT


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}


%files
%defattr(-,root,root,-)
%doc CHANGELOG COPYING CREDITS README
%{_javadir}/%{name}

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files argo
%defattr(-,root,root,-)
%{_javadir}/%{name}-argo.jar
%{_javadir}/%{name}-argo-%{version}.jar


%changelog
* Sat Oct 11 2003 Ville Skyttä <ville.skytta at iki.fi> - 1:1.1-1jpp
- Update to 1.1.
- Clean up jar manifests.
- Run unit tests during build.
- Non-versioned, crosslinked javadocs.

* Fri Apr 12 2003 David Walluck <david@antti-microsoft.org> 0:20020105-5jpp
- fix Vendor tag and add Distribution tag

* Fri Apr 11 2003 David Walluck <david@antti-microsoft.org> 0:20020105-4jpp
- rebuild for JPackage 1.5
- use -Dbuild.compiler=modern instead of USE_JIKES
- use java sdk >= 1.4.0 for org.xml support

* Wed Mar 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 20020105-3jpp
- dropped patch

* Wed Jan 23 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 20020105-2jpp 
- javadoc in %{_javadocdir} again 
- versioned jars rather than %{name} subdir
- macro section

* Tue Jan 8 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 20020105-1jpp
- javadoc back to /usr/share/doc
- no dependencies for javadoc packages
- used cvs snapshot
- buildrequires sablecc
- all jars but dresden-ocl-argo in dresden-ocl subdir
- regenerated patch

* Fri Dec 7 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 20001016-5jpp
- javadoc into javadoc package

* Sun Sep 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 20001016-4jpp
- more macros
- force modern compiler as jikes doesn't work

* Fri Sep 28 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 20001016-3jpp
- patched build file for missing classes needed by ArgoUML

* Tue Sep 25 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 20001016-2jpp
- first unified release
- splitted argo specific package
- added missing jars
- explicitly requires xerces-j1
- solved empty manual package
- s/jPackage/JPackage

* Sat Jun 23 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 20001016-1mdk
- first Mandrake release
